Attribute VB_Name = "Module1"
'===================================================================
' Aisa25.bas - aISA-A25 Win 9x Win32 API
' Copyright (c) ADTEK SYSTEM SCIENCE Co.,Ltd.
'===================================================================

Option Explicit

'-----------------------------------------------------------
' Miscellaneous
'-----------------------------------------------------------

Global Const AISA25_MAX_SLOTS = 8       ' Maximum number of slots
                                        ' (Master Board)

Global Const AISA25_SLOT_AUTO = &HFFFF  ' default search

'-----------------------------------------------------------
'  Device ID
'-----------------------------------------------------------
Global Const AISA25_VENDOR_ID = &H8B04
Global Const AISA25_DEVICE_ID = &H2541

' foCX ID ̎擾͉L̊֐gpĂB

'-----------------------------------------------------------
'  Board Select
'-----------------------------------------------------------

Global Const AISA25_EAB_BOARD_MAX = 9   ' P_XbgŊǗ
                                        ' Ƃł{[h̐
Global Const AISA25_EAB_MASTER = 0      ' }X^{[hI
Global Const AISA25_EAB_TARGET_0 = 1    ' PԖڂ̃^[Qbg{[hI
Global Const AISA25_EAB_TARGET_1 = 2    ' Q           V
Global Const AISA25_EAB_TARGET_2 = 3    ' R           V
Global Const AISA25_EAB_TARGET_3 = 4    ' S           V
Global Const AISA25_EAB_TARGET_4 = 5    ' T           V
Global Const AISA25_EAB_TARGET_5 = 6    ' U           V
Global Const AISA25_EAB_TARGET_6 = 7    ' V           V
Global Const AISA25_EAB_TARGET_7 = 8    ' W           V

'-----------------------------------------------------------
' ėpo͂̒l
'-----------------------------------------------------------

Global Const AISA25_EIO_OFF = 0
Global Const AISA25_EIO_ON = &HFFFFFFFF


'-----------------------------------------------------------
' Error codes
'-----------------------------------------------------------

Global Const AISA25_ERR_SYSTEM = 5000               ' Windows  GetLastError() R[ĂB
                                                    ' ̃tH_ɃhCoȂ\܂B
Global Const AISA25_ERR_NO_DEVICE = 5001            ' gp\ȃfoCX܂B
Global Const AISA25_ERR_IN_USED = 5002              ' w̃foCX͎gpłB
Global Const AISA25_ERR_INVALID_ARGUMENT = 5003     ' Invalid Argument(s)
Global Const AISA25_ERR_INVALID_SLOT = 5004         ' Ș_XbgłB
Global Const AISA25_ERR_INVALID_SEL_BOARD = 5005    ' ȃ{[hI܂B
Global Const AISA25_ERR_NOT_CREATED = 5006          ' foCXNGCgĂ܂B
Global Const AISA25_ERR_AIF = 5007                  ' AiO I/F G[܂B
Global Const AISA25_ERR_TIMEOUT = 5008              ' ^CAEg܂B
Global Const AISA25_ERR_NUMDATA = 5009              ' w肳ꂽ̃f[^obt@ɑ݂܂B
Global Const AISA25_ERR_NOT_ENOUGH_MEM = 5010       ' \ȃmۏo܂łB
Global Const AISA25_ERR_AD_CH_ENTRY_COUNT = 5011    ' A/D CH Gg̐ݒ肪słB
Global Const AISA25_ERR_AD_CH_ANALOG = 5012         ' A/D CH AiO̓`l̐ݒ肪słB
Global Const AISA25_ERR_AD_CH_SDBU = 5013           ' A/D CH oC|[-j|[AVOGh-fBt@V
                                                    ' ̐ݒ肪słB
Global Const AISA25_ERR_AD_CH_GAIN = 5014           ' A/D CH QC̐ݒ肪słB
Global Const AISA25_ERR_AD_MODE = 5015              ' A/D TvO[h̐ݒ肪słB
Global Const AISA25_ERR_AD_CH_ADDR = 5016           ' A/D TvO`lAhX̐ݒ肪słB
Global Const AISA25_ERR_AD_SAMPLING_RATE = 5017     ' A/D TvOx̐ݒ肪słB
Global Const AISA25_ERR_AD_SAMPLING_COUNT = 5018    ' A/D TvO񐔂̐ݒ肪słB
Global Const AISA25_ERR_AD_BUFF = 5019              ' A/D TvOobt@̐ݒ肪słB
Global Const AISA25_ERR_AD_SCN = 5020               ' A/D XLԍ̐ݒ肪słB
Global Const AISA25_ERR_AD_TRG_MODE = 5021          ' A/D xgK[h̐ݒ肪słB
Global Const AISA25_ERR_AD_TRG_DAC = 5022           ' A/D xgK DAC lsłB
Global Const AISA25_ERR_AD_TRG_EVENT = 5023         ' A/D xgKCxg񐔂̐ݒ肪słB
Global Const AISA25_ERR_NOT_EAB = 5024              ' EAB @\͎gpł܂B
Global Const AISA25_ERR_EAB_SCN_ADDR = 5025         ' EAB SCN AhX̐ݒ肪słB
Global Const AISA25_ERR_EAB_SCN_COUNT = 5026        ' EAB SCN o^̐ݒ肪słB
Global Const AISA25_ERR_EAB_SCN = 5027              ' EAB SCN ̐ݒ肪słB
Global Const AISA25_ERR_AD_START = 5028             ' A/D TvOJnł܂BAdSetMode sĂ
                                                    ' B
Global Const AISA25_ERR_AD_BUSY = 5029              ' A/D Rg[ғłB
Global Const AISA25_ERR_AD_BUFF_NOT_EMPTY = 5030    ' A/D hCoobt@Ƀf[^cĂ܂BAdGetData ܂
                                                    ' AdSetMode sĂB
Global Const AISA25_ERR_AD_SYNC_START = 5031        ' A/D TvȌꍇA^[QbgJnł܂B
Global Const AISA25_ERR_AD_SYNC_STOP = 5032         ' A/D TvȌꍇA^[Qbg~ł܂B
Global Const AISA25_ERR_AD_SYNC_SCN = 5033          ' A/D TvOAVOTvȌꍇAXL
                                                    ' ԍ(SCN)𓝈ꂵĂB
Global Const AISA25_ERR_AD_SYNC_CNV_RATE = 5034     ' A/D TvO̕ϊxA܂̓}X^̃^C}
                                                    ' ݒlsłB
Global Const AISA25_ERR_AD_SYNC_BUFF = 5035         ' A/D TvȌꍇA}X^ƃ^[Qbg̃obt@TCY
                                                    ' 𓝈ꂵĂB
Global Const AISA25_ERR_DA_MODE = 5036              ' D/A [h̐ݒ肪słB
Global Const AISA25_ERR_DA_SAMPLING_RATE = 5037     ' D/A TvOx̐ݒ肪słB
Global Const AISA25_ERR_DA_ENTRY_COUNT = 5038       ' D/A TvOf[^słB
Global Const AISA25_ERR_DA_BUSY = 5039              ' D/A Rg[ғłB
Global Const AISA25_ERR_DA_ENTRY_DATA = 5040        ' D/A TvOf[^o^Ă܂B

Global Const AISA25_ERR_INTERNAL = 5100             ' Send mail to us
Global Const AISA25_ERR_UNKNOWN = 5101              ' Help me!
Global Const AISA25_SUCCESS = 0                     ' Successfully proccessed


'-----------------------------------------------------------
' Resource information structure
'-----------------------------------------------------------

Global Const AISA25_MAX_MEM = 9          ' number of memory windows
Global Const AISA25_MAX_IO = 20          ' number of i/o windows
Global Const AISA25_MAX_IRQ = 7          ' number of irqs
Global Const AISA25_MAX_DMA = 7          ' number of dmas

Type AISA25RESOURCE
    dwNumMemWindows As Long                     ' Not used
    dwMemBase(1 To AISA25_MAX_MEM) As Long      ' Not used
    dwMemLength(1 To AISA25_MAX_MEM) As Long    ' Not used
    dwMemAttrib(1 To AISA25_MAX_MEM) As Long    ' Not used
    dwNumIOPorts As Long                        ' Num IO ports
    dwIOPortBase(1 To AISA25_MAX_IO) As Long    ' I/O port base
    dwIOPortLength(1 To AISA25_MAX_IO) As Long  ' I/O port length
    dwNumIRQs As Long                           ' Num IRQ info
    dwIRQRegisters(1 To AISA25_MAX_IRQ) As Long ' IRQ list
    dwIRQAttrib(1 To AISA25_MAX_IRQ) As Long    ' IRQ Attrib list
    dwNumDMAs As Long                           ' Not used
    dwDMALst(1 To AISA25_MAX_DMA) As Long       ' Not used
    dwDMAAttrib(1 To AISA25_MAX_DMA) As Long    ' Not used
    dwReserved1(1 To 3) As Long                 ' Not used
End Type


'-----------------------------------------------------------
' Channel Entry Data structure
'-----------------------------------------------------------

' ݒ`l̃AhX
Global Const AISA25_AD_CH_ADDR_MAX = 16

Global Const AISA25_AD_CH_ADDR_FIRST = &H0
Global Const AISA25_AD_CH_0H = &H0
Global Const AISA25_AD_CH_1H = &H1
Global Const AISA25_AD_CH_2H = &H2
Global Const AISA25_AD_CH_3H = &H3
Global Const AISA25_AD_CH_4H = &H4
Global Const AISA25_AD_CH_5H = &H5
Global Const AISA25_AD_CH_6H = &H6
Global Const AISA25_AD_CH_7H = &H7
Global Const AISA25_AD_CH_8H = &H8
Global Const AISA25_AD_CH_9H = &H9
Global Const AISA25_AD_CH_AH = &HA
Global Const AISA25_AD_CH_BH = &HB
Global Const AISA25_AD_CH_CH = &HC
Global Const AISA25_AD_CH_DH = &HD
Global Const AISA25_AD_CH_EH = &HE
Global Const AISA25_AD_CH_FH = &HF
Global Const AISA25_AD_CH_ADDR_LAST = &HF

' ̓`l̐ݒl
Global Const AISA25_AD_CH_MAX = 16

Global Const AISA25_AD_CH_FIRST = 0
Global Const AISA25_AD_CH_01 = 0
Global Const AISA25_AD_CH_02 = 1
Global Const AISA25_AD_CH_03 = 2
Global Const AISA25_AD_CH_04 = 3
Global Const AISA25_AD_CH_05 = 4
Global Const AISA25_AD_CH_06 = 5
Global Const AISA25_AD_CH_07 = 6
Global Const AISA25_AD_CH_08 = 7
Global Const AISA25_AD_CH_09 = 8
Global Const AISA25_AD_CH_10 = 9
Global Const AISA25_AD_CH_11 = 10
Global Const AISA25_AD_CH_12 = 11
Global Const AISA25_AD_CH_13 = 12
Global Const AISA25_AD_CH_14 = 13
Global Const AISA25_AD_CH_15 = 14
Global Const AISA25_AD_CH_16 = 15
Global Const AISA25_AD_CH_LAST_D = 7        ' fBt@V͎̍ŏIl
Global Const AISA25_AD_CH_LAST_S = 15       ' VOGh͎̍ŏIl

                           ' dwSdBu b SingleEnd/Differentialb Bipolar-Unipolar
                           ' ---------------------------------------------------
Global Const AISA25_AD_SDBU_0 = 0 ' b       SingleEnd       b     Bipolar
Global Const AISA25_AD_SDBU_1 = 1 ' b       SingleEnd       b     Unipolar
Global Const AISA25_AD_SDBU_2 = 2 ' b      Differential     b     Bipolar
Global Const AISA25_AD_SDBU_3 = 3 ' b      Differential     b     Unipolar

                              ' dwGainb Gain b Bipolar b Unipolar
                              ' ------------------------------------------
Global Const AISA25_AD_GAIN_01 = 1  ' b 1 { b }10V   b 0`+10V
Global Const AISA25_AD_GAIN_05 = 5  ' b 5 { b }2V    b 0`+2V
Global Const AISA25_AD_GAIN_10 = 10 ' b 10{ b }1V    b 0`+1V
Global Const AISA25_AD_GAIN_50 = 50 ' b 50{ b }200mV b 0`+200mV

Type AISA25ADCHE
    dwChAnalog As Long      ' AiO̓`lw
    dwSdBu As Long          ' VOGh-ft@VAoC|[-j|[̎w
    dwGain As Long          ' 1{A5{A10{A50{̒w
End Type

'-----------------------------------------------------------
' Sampling definition
'-----------------------------------------------------------

' TvO[h
                            ' dwAdModeb  -ĕ@  bݸމ񐔁bb     荞      b
                            ' -------------------------------------  ---------------------
Global Const AISA25_AD_MODE_00 = 0  ' b         b     1      bb        EOC        b
Global Const AISA25_AD_MODE_01 = 1  ' b         b  1`65536  bb    ݸEND    b
Global Const AISA25_AD_MODE_02 = 2  ' bض b  1`65536  bb    ݸEND    b
Global Const AISA25_AD_MODE_03 = 3  ' bOض b  1`65536  bb    ݸEND    b
Global Const AISA25_AD_MODE_04 = 4  ' b         b          bbFIFO HALF,FULL,OVRFb
Global Const AISA25_AD_MODE_05 = 5  ' b  Oض  b     1      bb        EOC        b
Global Const AISA25_AD_MODE_06 = 6  ' b߽ضށb  1`65536  bb    ݸEND    b
Global Const AISA25_AD_MODE_07 = 7  ' bO߽ضށb  1`65536  bb    ݸEND    b
Global Const AISA25_AD_MODE_08 = 8  ' bϽްނbϽްނ̐݁bb  Ͻްނ̐ݒ   b
                                    ' b    bɂ    bb     ɂ        b

                       ' dwSelCnvRate     bϊx
                       ' ---------------------------------------
Global Const AISA25_AD_RATE_LOW = 0     ' b20us
Global Const AISA25_AD_RATE_HIGH = 1    ' b10us

                       ' dwSelClock       bNbN
                       ' ---------------------------------------
Global Const AISA25_AD_CLOCK_100K = 0   ' b100KHz
Global Const AISA25_AD_CLOCK_10M = 1    ' b 10MHz
Global Const AISA25_AD_CLOCK_EXT = 2    ' b O

Global Const AISA25_AD_TIME_MIN_CL100K = 1  ' NbN 100KHz I̍ŏl
Global Const AISA25_AD_TIME_MIN_CL10M = 100 ' NbN 10MHz I̍ŏl
                                            ' ̃NbNŏĺAϊx HIGH ɂꍇ̒l
                                            ' ϊx LOW ɂꍇ́AŏlQ{ɂȂ܂B
Global Const AISA25_AD_TIME_MIN_CLEXT = 1   ' ONbNI̍ŏl
Global Const AISA25_AD_TIME_MAX = 65536

Global Const AISA25_AD_COUNT_MIN = 1            ' TvO񐔂̍ŏl
Global Const AISA25_AD_COUNT_MAX = 65536        ' TvO񐔂̍ől

Global Const AISA25_AD_BUFF_MIN = 1             ' obt@TCY̍ŏl

            '             dwTrgMode   bxgK[h          bdwTrgLvl1bdwTrgLvl2b
            '           --------------------------------------------------------------------
Global Const AISA25_AD_LVLTRG_0 = 0 ' bGbWgK      b       b         b
Global Const AISA25_AD_LVLTRG_1 = 1 ' bオGbWgK      b       b         b
Global Const AISA25_AD_LVLTRG_2 = 2 ' bCEChgK(͈͓)  b       b       b
Global Const AISA25_AD_LVLTRG_3 = 3 ' bAEgEChgK(͈͊O)b       b       b
Global Const AISA25_AD_LVLTRG_4 = 4 ' b}CiXX[vgK      b       b       b
Global Const AISA25_AD_LVLTRG_5 = 5 ' bvXX[vgK        b       b       b

Global Const AISA25_AD_LVLTRG_DAC = &HFF        ' AiO͐MK

Global Const AISA25_AD_LVLTRG_EVENT_MIN = 0     ' gK̍ŏl
Global Const AISA25_AD_LVLTRG_EVENT_MAX = 65536 ' gK̍ől

Global Const AISA25_AD_EAB_SCN_FIRST = &H0      ' EAB Scan Number First
Global Const AISA25_AD_EAB_SCN_0 = &H0          '        V       0
Global Const AISA25_AD_EAB_SCN_1 = &H1          '        V       1
Global Const AISA25_AD_EAB_SCN_2 = &H2          '        V       2
Global Const AISA25_AD_EAB_SCN_3 = &H3          '        V       3
Global Const AISA25_AD_EAB_SCN_4 = &H4          '        V       4
Global Const AISA25_AD_EAB_SCN_5 = &H5          '        V       5
Global Const AISA25_AD_EAB_SCN_6 = &H6          '        V       6
Global Const AISA25_AD_EAB_SCN_7 = &H7          '        V       7
Global Const AISA25_AD_EAB_SCN_LAST = &H7       '        V       Last

Type AISA25ADMODE
    dwMode As Long          ' 샂[h
    dwChAddrFirst As Long   ' TvOJn`lAhX(0-15)
    dwChAddrLast As Long    ' TvOI`lAhX(0-15)
    dwSelCnvRate As Long    ' ϊx
    dwSelClock As Long      ' TvONbN
    dwTimer As Long         ' TvO^C}(1-65536)
    dwCount As Long         ' TvO񐔂ݒ(1-65536)
    dwBuffer As Long        ' obt@TCYAIɊmۂłlől
    dwTrgMode As Long       ' xgK[hݒ
    dwTrgLvl1 As Long       ' xgKDACl1̐ݒ(00`FFh ͓dWɂ܂)
                            ' {dwTrgLvl1 > dwTrgLvl2}
    dwTrgLvl2 As Long       ' xgKDACl2̐ݒ(00`FFh ͓dWɂ܂)
    dwTrgEvent As Long      ' Cxg(0-65536)
    dwScn As Long           ' e{[h EAB XLԍ(SCN)
End Type


' SCN ݒ̃AhX
Global Const AISA25_AD_SCN_ADDR_MAX = 16

Global Const AISA25_AD_SCN_ADDR_FIRST = &H0
Global Const AISA25_AD_SCN_0H = &H0
Global Const AISA25_AD_SCN_1H = &H1
Global Const AISA25_AD_SCN_2H = &H2
Global Const AISA25_AD_SCN_3H = &H3
Global Const AISA25_AD_SCN_4H = &H4
Global Const AISA25_AD_SCN_5H = &H5
Global Const AISA25_AD_SCN_6H = &H6
Global Const AISA25_AD_SCN_7H = &H7
Global Const AISA25_AD_SCN_8H = &H8
Global Const AISA25_AD_SCN_9H = &H9
Global Const AISA25_AD_SCN_AH = &HA
Global Const AISA25_AD_SCN_BH = &HB
Global Const AISA25_AD_SCN_CH = &HC
Global Const AISA25_AD_SCN_DH = &HD
Global Const AISA25_AD_SCN_EH = &HE
Global Const AISA25_AD_SCN_FH = &HF
Global Const AISA25_AD_SCN_ADDR_LAST = &HF

Type AISA25ADEAB
    dwScnAddrFirst As Long                          ' EAB Jn SCN Gg RAM AhX
    dwScnAddrLast As Long                           ' EAB I SCN Gg RAM AhX
    dwScnCount As Long                              ' EAB SCN Gg RAM ւ̓o^f[^
    dwScnEntry(1 To AISA25_AD_SCN_ADDR_MAX) As Long ' EAB SCN Gg RAM ւ̓o^f[^
End Type


' TvOXe[^X
Global Const AISA25_STS_SAMPLING = &H1
Global Const AISA25_STS_EOC = &H2
Global Const AISA25_STS_SAMPLING_END = &H4
Global Const AISA25_STS_BUFF_HALF_FULL = &H8
Global Const AISA25_STS_BUFF_FULL = &H10
Global Const AISA25_STS_BUFF_OVERFLOW = &H20
Global Const AISA25_STS_SAMPLING_OVERRUN = &H40
Global Const AISA25_STS_FIFO_EXIST = &H80           ' FIFO obt@Ƀf[^݂

' Aisa25Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
' ItZbglbZ[Wo܂B
Global Const WM_EOC = 0
Global Const WM_SAMPLING_END = 1
Global Const WM_BUFF_HALF_FULL = 2
Global Const WM_BUFF_FULL = 3
Global Const WM_BUFF_OVERFLOW = 4
Global Const WM_SAMPLING_OVERRUN = 5

' bZ[W wParam  wLogSlot ̒l擾
' wLogSlot ̎擾͉L̊֐gpĂB

' bZ[W wParam  wSelBoard ̒l擾
' wSelBoard ̎擾͉L̊֐gpĂB

'-----------------------------------------------------------
' DA TvO^C}̃NbN
'-----------------------------------------------------------
                       ' dwSelClock       bNbN
                       ' ---------------------------------------
Global Const AISA25_DA_CLOCK_100K = 0   ' b100KHz
Global Const AISA25_DA_CLOCK_10M = 1    ' b 10MHz

Global Const AISA25_DA_TIME_MIN_CL10M = 100     ' NbN 10MHz I̍ŏl
Global Const AISA25_DA_TIME_MIN_CL100K = 1      ' NbN 100KHz I̍ŏl
Global Const AISA25_DA_TIME_MAX = 65536

Global Const AISA25_DA_DATA_ALL_MAX = 32768
Global Const AISA25_DA_DATA_BANK_MAX = 4096

Global Const AISA25_DA_BANK_MAX = 8             ' D/A oN̍ő吔

Global Const AISA25_DA_MODE_ALL = &HFFFFFFFF
Global Const AISA25_DA_MODE_BANK_0 = 0
Global Const AISA25_DA_MODE_BANK_1 = 1
Global Const AISA25_DA_MODE_BANK_2 = 2
Global Const AISA25_DA_MODE_BANK_3 = 3
Global Const AISA25_DA_MODE_BANK_4 = 4
Global Const AISA25_DA_MODE_BANK_5 = 5
Global Const AISA25_DA_MODE_BANK_6 = 6
Global Const AISA25_DA_MODE_BANK_7 = 7


'-----------------------------------------------------------
' API Functions
'-----------------------------------------------------------

' ʏgp
Public Declare Function Aisa25GetVersion Lib "aisa25" (ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Long
Public Declare Function Aisa25Create Lib "aisa25" (ByRef pwLogSlot As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Any) As Long
Public Declare Function Aisa25Close Lib "aisa25" (ByVal wLogSlot As Integer) As Long
Public Declare Function Aisa25GetResource Lib "aisa25" (ByVal wLogSlot As Integer, ByRef pres As AISA25RESOURCE) As Long
Public Declare Function Aisa25GetNumBoard Lib "aisa25" (ByVal wLogSlot As Integer, ByRef pwNumBoard As Integer) As Long
Public Declare Function Aisa25GetSwitchValue Lib "aisa25" (ByVal wLogSlot As Integer, ByRef pdwSwitchValue As Long) As Long
Public Declare Function Aisa25Reset Lib "aisa25" (ByVal wLogSlot As Integer) As Long
Public Declare Function Aisa25Adc Lib "aisa25" (ByVal wLogSlot As Integer) As Long
Public Declare Function Aisa25AdGetChEntry Lib "aisa25" (ByVal wLogSlot As Integer, ByVal dwChCount As Long, ByRef pEntries As AISA25ADCHE) As Long
Public Declare Function Aisa25AdSetChEntry Lib "aisa25" (ByVal wLogSlot As Integer, ByVal dwChCount As Long, ByRef pEntries As AISA25ADCHE) As Long
Public Declare Function Aisa25AdSetMode Lib "aisa25" (ByVal wLogSlot As Integer, ByRef pmode As AISA25ADMODE) As Long
Public Declare Function Aisa25AdStartSampling Lib "aisa25" (ByVal wLogSlot As Integer) As Long
Public Declare Function Aisa25AdStopSampling Lib "aisa25" (ByVal wLogSlot As Integer) As Long
Public Declare Function Aisa25AdGetSamplingStatus Lib "aisa25" (ByVal wLogSlot As Integer, ByRef pdwNumData As Long, ByRef pdwStatus As Long) As Long
Public Declare Function Aisa25AdGetData Lib "aisa25" (ByVal wLogSlot As Integer, ByRef pdwNumData As Long, ByRef pwData As Integer) As Long
Public Declare Function Aisa25DaSetRateSampling Lib "aisa25" (ByVal wLogSlot As Integer, ByVal dwSelClock As Long, ByVal dwTimer As Long) As Long
Public Declare Function Aisa25DaSetDataEntry Lib "aisa25" (ByVal wLogSlot As Integer, ByVal dwDaMode As Long, ByVal dwDataCount As Long, ByRef pwDataEntry As Integer) As Long
Public Declare Function Aisa25DaStartSampling Lib "aisa25" (ByVal wLogSlot As Integer, ByVal dwDaMode As Long) As Long
Public Declare Function Aisa25DaStopSampling Lib "aisa25" (ByVal wLogSlot As Integer) As Long
Public Declare Function Aisa25DaSetData Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wDaData As Integer) As Long
Public Declare Function Aisa25GetEIn Lib "aisa25" (ByVal wLogSlot As Integer, ByRef pdwEIn1 As Long, ByRef pdwEIn2 As Long, ByRef pdwEIn3 As Long) As Long
Public Declare Function Aisa25SetEOut Lib "aisa25" (ByVal wLogSlot As Integer, ByVal dwEOut1 As Long, ByVal dwEOut2 As Long, ByVal dwEOut3 As Long) As Long
Public Declare Function Aisa25GetLastError Lib "aisa25" (ByVal wLogSlot As Integer) As Long

' EAB gp
Public Declare Function Aisa25GetSwitchValueEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByRef pdwSwitchValue As Long) As Long
Public Declare Function Aisa25ResetEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer) As Long
Public Declare Function Aisa25AdcEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer) As Long
Public Declare Function Aisa25AdGetChEntryEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwChCount As Long, ByRef pEntries As AISA25ADCHE) As Long
Public Declare Function Aisa25AdSetChEntryEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwChCount As Long, ByRef pEntries As AISA25ADCHE) As Long
Public Declare Function Aisa25AdSetModeEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByRef pmode As AISA25ADMODE) As Long
Public Declare Function Aisa25AdSetEab Lib "aisa25" (ByVal wLogSlot As Integer, ByRef peab As AISA25ADEAB) As Long
Public Declare Function Aisa25AdStartSamplingEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer) As Long
Public Declare Function Aisa25AdStopSamplingEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer) As Long
Public Declare Function Aisa25AdGetSamplingStatusEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByRef pdwNumData As Long, ByRef pdwStatus As Long) As Long
Public Declare Function Aisa25AdGetDataEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByRef pdwNumData As Long, ByRef pwData As Integer) As Long
Public Declare Function Aisa25DaSetRateSamplingEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwSelClock As Long, ByVal dwTimer As Long) As Long
Public Declare Function Aisa25DaSetDataEntryEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwDaMode As Long, ByVal dwDataCount As Long, ByRef pwDataEntry As Integer) As Long
Public Declare Function Aisa25DaStartSamplingEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwDaMode As Long) As Long
Public Declare Function Aisa25DaStopSamplingEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer) As Long
Public Declare Function Aisa25DaSetDataEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal wDaData As Integer) As Long
Public Declare Function Aisa25GetEInEx Lib "aisa25" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByRef pdwEIn1 As Long, ByRef pdwEIn2 As Long, ByRef pdwEIn3 As Long) As Long
Public Declare Function Aisa25SetEOutEx Lib "aisa57" (ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwEOut1 As Long, ByVal dwEOut2 As Long, ByVal dwEOut3 As Long) As Long

'****************************************************************************'
'    aISA-A25 ̃bZ[W lParam  foCX ID ̒l擾           *'
'    lParam  bZ[W                                                 *'
' ߂l foCX ID                                                        *'
'****************************************************************************'
Function Aisa25GetDeviceID(lParam As Long) As Long

    Aisa25GetDeviceID = lParam And &HFFFF

End Function

'****************************************************************************'
'*    aISA-A25 ̃bZ[W wParam  wLogSlot ̒l擾           *'
'*    wParam  bZ[W                                                *'
'* ߂l wLogSlot                                                          *'
'****************************************************************************'
Function Aisa25GetLogSlot(wParam As Long) As Long

    Aisa25GetLogSlot = wParam And &HFFFF

End Function

'****************************************************************************'
'*    aISA-A25 ̃bZ[W wParam  wSelBoard ̒l擾            *'
'*    wParam  bZ[W                                                *'
'* ߂l wSelBoard                                                         *'
'****************************************************************************
Function Aisa25GetSelBoard(wParam As Long) As Long

    Aisa25GetSelBoard = (wParam / &H10000) And &HFFFF

End Function

